
from __future__ import print_function

import os
import pathlib
from xml.etree import cElementTree as ET

import osc.core


def run_source_services(service_data, obspkgdir):
    # Parse the service XML data
    try:
        service_xml = ET.fromstring(service_data)
    except ET.ParseError as v:
        line, column = v.position
        print("XML error in source service data on line {}, column {}".format(line, column))
        sys.exit(10)

    # Execute the source services
    svc_info = osc.core.Serviceinfo()
    svc_info.read(service_xml)

    # Service must be run in project dir...
    curdir = os.getcwd()
    os.chdir(obspkgdir)
    svc_exec = svc_info.execute(obspkgdir)
    os.chdir(curdir)
    return svc_exec
